;/***********************************************************************
;
;************************************************************************
;
;  SA11x0 defines
;
;       NOTE: This is a multi-hosted header file for use with uHAL and
;             supported debuggers.
;
;             This file MUST be kept in synch with sa11x0.h!
; 
;***********************************************************************/

#define BIT0                         0x00000001
#define BIT1                         0x00000002
#define BIT2                         0x00000004
#define BIT3                         0x00000008
#define BIT4                         0x00000010
#define BIT5                         0x00000020
#define BIT6                         0x00000040
#define BIT7                         0x00000080
#define BIT8                         0x00000100
#define BIT9                         0x00000200
#define BIT10                        0x00000400
#define BIT11                        0x00000800
#define BIT12                        0x00001000
#define BIT13                        0x00002000
#define BIT14                        0x00004000
#define BIT15                        0x00008000
#define BIT16                        0x00010000
#define BIT17                        0x00020000
#define BIT18                        0x00040000
#define BIT19                        0x00080000
#define BIT20                        0x00100000
#define BIT21                        0x00200000
#define BIT22                        0x00400000
#define BIT23                        0x00800000
#define BIT24                        0x01000000
#define BIT25                        0x02000000
#define BIT26                        0x04000000
#define BIT27                        0x08000000
#define BIT28                        0x10000000
#define BIT29                        0x20000000
#define BIT30                        0x40000000
#define BIT31                        0x80000000

#define SZ_256                       0x00000100
#define SZ_1K                        0x00000400
#define SZ_8K                        0x00002000
#define SZ_16K                       0x00004000
#define SZ_32K                       0x00008000
#define SZ_64K                       0x00010000
#define SZ_128K                      0x00020000
#define SZ_256K                      0x00040000
#define SZ_512K                      0x00080000
#define SZ_1M                        0x00100000
#define SZ_2M                        0x00200000
#define SZ_4M                        0x00400000
#define SZ_8M                        0x00800000
#define SZ_16M                       0x01000000
#define SZ_32M                       0x02000000
#define SZ_64M                       0x04000000
#define SZ_96M                       0x06000000
#define SZ_128M                      0x08000000
#define SZ_256M                      0x10000000
#define SZ_512M                      0x20000000
#define SZ_1G                        0x40000000

; /* SA1110 REGISTERS */
#define MEM_CONFIG_BASE              0xA0000000
#define MDCNFG                       0xA0000000  ; base address
#define MDCAS00                      0x04        ; offset from base
#define MDCAS01                      0x08        ; offset from base
#define MDCAS02                      0x0C        ; offset from base
#define MSC0                         0x10        ; offset from base
#define MSC1                         0x14        ; offset from base
#define MECR                         0x18        ; offset from base
#define MDREFR                       0x1C        ; offset from base
#define MDCAS20                      0x20        ; offset from base
#define MDCAS21                      0x24        ; offset from base
#define MDCAS22                      0x28        ; offset from base
#define MSC2                         0x2C        ; offset from base
#define SMCNFG                       0x30        ; offset from base

#define MDREFR_KAPD                  BIT29
#define MDREFR_EAPD                  BIT28
#define MDCNFG_DWID0                 BIT3
#define MDCNFG_DWID2                 BIT19

#define RT_ROM_FLASH                 0
#define RT_ROM_SRAM                  1
#define RT_B4ROM                     2
#define RT_B8ROM                     3

#define GPIOREGBASE                  0x90040000
#define GPIO_BASE                    0x90040000
#define GPIO_OFFSET                  0x40000      ; offset from scm_base
#define GPLR                         0x00
#define GPDR                         0x04
#define GPSR                         0x08
#define GPCR                         0x0C
#define GRER                         0x10
#define GFER                         0x14
#define GEDR                         0x18
#define GAFR                         0x1C

#define SSP_BASE                     0x80070060
#define SSCR0                        0x00
#define SSCR1                        0x04
#define SSDR                        0x0c
#define SSSR                        0x14

; /* Power Mgr regs */
#define POWERMGR_BASE                0x90020000
#define PSSR                         0x04
#define PSPR                         0x08

; /* Reset Controller regs */
#define RESETCNTRLR_BASE             0x90030000
#define RSRR                         0x00
#define RCSR                         0x04
#define TUCR                         0x08
; /* Reset bits */
#define RCSR_HWR                     0x1
#define RCSR_SWR                     0x2
#define RCSR_WDR                     0x4
#define RCSR_SMR                     0x8

; /* SDLC */
#define SDLC_BASE                    0x80020000
#define SDCR0                        0x60

; /* MCP values */
#define PERIPHERALS                  0x80000000   ; base addr of peripheral devices
#define MCP_BASE                     0x60000      ; offset from peripherals
#define MCCR0                        0x0          ; offset from mcp_base
#define MCDR2                        0x10         ; offset from mcp_base
#define MCSR                         0x18         ; offset from mcp_base
#define DIRX_REG                     0x20000      ; mcp port direction reg
#define MCP_WRITE                    0x10000      ; mcp register write request
#define SIB_ZERO                     0x8000       ; sib-zero bit port dirx reg
#define MCP_LEDS                     0x60         ; mcp LED devices
#define MCP_RED                      0x40
#define MCP_GRN                      0x20

; /* GPIO values */
#define GPUART1_RXD                  BIT15
#define GPUART1_TXD                  BIT14
#define GPUART3_TXD                  BIT0

; /* Interrupt Controller */
#define IC_BASE                      0x90050000      ; 
#define ICIP                         0x00            ; IRQ pending register 
#define ICMR                         0x04            ; Mask register
#define ICLR                         0x08            ; level 0=IRQ 1=FIQ
#define ICFP                         0x10            ; FIQ pending register
#define ICPR                         0x20            ; Pending register

; /* Interrupt bits */
#define UART1_INT                    BIT15
#define UART3_INT                    BIT17
#define HZ_TIC_INT                   0x40000000
#define RTC_ALM_INT                  0x40000000

; /* PPCR */
#define PPCR_BASE                    0x90020000
#define PPCR                         0x14
; /* PPCR values */
#define PPCR_K_147MHz                0x6
#define PPCR_K_162MHz                0x7
#define PPCR_K_200MHz                0xA

; /* PPAR: PPC Pin Assignment Register */
#define PPAR                         0x90060008
#define PPA_UART                     0x1000
        
; /* UART regs/values */
#define UTCR0                        0x00
#define UTCR1                        0x04
#define UTCR2                        0x08
#define UTCR3                        0x0C
#define UTDR                         0x14
#define UTSR0                        0x1C
#define UTSR1                        0x20

#define SA11_SKCR              0x00
; /* Line status bits. */
#define SA11_SKID                   0x08
#define SA11_SMCR                   0x04
#define SA11_SKPCR                   0x0
#define SA11_SKCDR                   0x04
#define SA11_SKAUD                   0x08
#define SA11_SACR0                   0x00
#define SA11_SACR1                   0x04
#define SA11_SACR2                   0x08
#define SA11_SASR0                   0x0C
#define SA11_SASR1                   0x10
#define SA11_SASR2                   0x08
#define SA11_GPIO_C_DATA             0x24
#define SA11_GPIO_C_DDR              0x20
#define SA11_GPIO_C_SDR              0x28
#define SA11_GPIO_A_DATA             0x04
#define SA11_GPIO_A_DDR              0x0
#define SA11_ID                    0x690c0000
#define SA11_SCR                    0x0200
#define SA11_SACR_BASE               0x600
#define SA11_GPIO_BASE               0x1000 
#define SA11_BASE      0x40000000
